
jQuery.foolNameSpace = function() {
    var a=arguments, o=null, i, j, d;
    for (i=0; i<a.length; i=i+1) {
        d=a[i].split(".");
        o=window;
        for (j=0; j<d.length; j=j+1) {
            o[d[j]]=o[d[j]] || {};
            o=o[d[j]];
        }
    }
    return o;
};

jQuery.foolNameSpace('Fool');

Fool.Base = function($) {
	
    // private
    var self, domain = SiteInfo.domain;
	
	//public
    return {

        initialize: function() {
            self = this;
            this.eatConsole();
            this.setPrintables();
            this.animateStuff();
            this.orderPageSlideInCta();

            this.promoItemsEffects();
        },

        setPrintables: function(){
            $(".print-printables").click(function() {
                // Print the DIV.
                $(".printable").print();
                // Cancel click event.
                return( false );
            }); 
        },

        eatConsole: function() {
            /* Let IE and other browsers eat calls to console.log accidentally committed to svn */
            if (typeof console == 'undefined') {
                window.console = {
                    log: function(msg) { return; },info: function(msg) { return; },
                    debug: function(msg) { return; },warn: function(msg) { return; },
                    error: function(msg) { return; },dir: function() { return; },
                    time: function() { return; },timeEnd: function() { return; },
                    profile: function() { return; },profileEnd: function() { return; },
                    trace: function() { return; },group: function() { return; },groupEnd: function() { return; }
                };
            }
        },

        getTimeString: function(oDate) {
            if (!oDate) {
                oDate = new Date();
            }
            
            var sMonths, sDate, sHours, sMinutes, sSeconds, sMilliseconds;
            var sTime = oDate.getFullYear().toString();

            sMonths = (oDate.getMonth() + 1).toString(); // zero-based
            sTime += sMonths.length == 1 ? "0" + sMonths : sMonths;

            sDate = oDate.getDate().toString();
            sTime += sDate.length == 1 ? "0" + sDate : sDate;

            sHours = oDate.getHours().toString();
            sTime += sHours.length == 1 ? "0" + sHours : sHours;

            sMinutes = oDate.getMinutes().toString();
            sTime += sMinutes.length == 1 ? "0" + sMinutes : sMinutes;

            sSeconds = oDate.getSeconds().toString();
            sTime += sSeconds.length == 1 ? "0" + sSeconds : sSeconds;

            sMilliseconds = oDate.getMilliseconds().toString();
            if (sMilliseconds.length == 1) {
                sTime += "00" + sMilliseconds;
            }
            else if (sMilliseconds.length == 2) {
                sTime += "0" + sMilliseconds;
            }
            else {
                sTime += sMilliseconds;
            }

            return sTime;
        },

        // Cookie Util functions
        setCookie: function(cookieName){
            if(Fool.Base.getCookie(cookieName)){
                if(Fool.Base.getCookie(cookieName) !== '-1'){
                    var newValue = parseInt(Fool.Base.getCookie(cookieName)) + 1;
                    jQuery.cookie(cookieName, newValue, { expires: 7, path: '/', domain: domain });
                }	
            } else {
                jQuery.cookie(cookieName, 1, { expires: 7, path: '/', domain: domain });
            }
        },

        parseVars: function(queryVars){
            var vars = [], hash;
            var hashes = queryVars.split('&');
            for(var i = 0; i < hashes.length; i++)
            {
                hash = hashes[i].split('=');
                vars.push(hash[0]);
                vars[hash[0]] = hash[1];
            }
            return vars;
        },
		
        getCookie: function(cookieName){
            return document.cookie.indexOf(cookieName) != -1 ? jQuery.cookie(cookieName) : false;
        },
        resetCookie: function(cookieName){
            jQuery.cookie(cookieName, 1, { expires: 7, path: '/', domain: domain });
        },
        killCookie: function(cookieName){
            jQuery.cookie(cookieName, -1, { expires: 3650, path: '/', domain: domain });  /* ecapped, don't recreate */
        },

        getParameterByName: function(name) {
            name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
            var regexS = "[\\?&]" + name + "=([^&#]*)";
            var regex = new RegExp(regexS);
            var results = regex.exec(window.location.href);
            if(results == null)
                return "";
            else
                return decodeURIComponent(results[1].replace(/\+/g, " "));
        },

        htmlEntities: function(str) {
            if(!str) return;
            return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
        },

        animateStuff: function() {

            var $animation_elements = $('.animation-element');
            var $window = $(window);
            var $classTest = '';

            function check_if_in_view() {
                var window_height = $window.height();
                var window_top_position = $window.scrollTop();
                var window_bottom_position = (window_top_position + window_height);

                $.each($animation_elements, function() {
                    var $element = $(this);
                    var element_height = $element.outerHeight();
                    var element_top_position = $element.offset().top;
                    var element_bottom_position = (element_top_position + element_height);

                    // KM Get the trigger class
                    if($element.hasClass('bid')) {
                        $classTest = "bounceInDown";
                    }
                    else if($element.hasClass('bir')) {
                        $classTest = "bounceInRight";
                    }
                    else if($element.hasClass('bil')) {
                        $classTest = "bounceInLeft";
                    }
                    else if($element.hasClass('fiub')) {
                        $classTest = "fadeInUpBig";
                    }
                    else if($element.hasClass('firb')) {
                        $classTest = "fadeInRightBig";
                    }
                    else if($element.hasClass('pls')) {
                        $classTest = "pulse";
                    }
                    else if($element.hasClass('swg')) {
                        $classTest = "swing";
                    }  

                    //check to see if this current container is within viewport
                    var animationEnd = 'webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend';
                    if ((element_bottom_position >= window_top_position) && (element_top_position <= window_bottom_position)) {
                        $element.addClass('in-view ' + $classTest).one(animationEnd);
                    } else {
                        $element.removeClass('in-view ' + $classTest);
                    }


                });
            }

            $window.on('scroll resize', check_if_in_view);
            $window.trigger('scroll');
        },

        orderPageSlideInCta: function(){

            $(window).scroll(function(){
                if($("#form-anchor").length > 0){
                    /* when reaching the element with id "last" we want to show the slidebox. Let's get the distance from the top to the element */
                    var distanceTop = $('#form-anchor').offset().top - $(window).height();

                    if  ($(window).scrollTop() < distanceTop && $(window).scrollTop() > 100){
                        $( ".peekaboo" ).slideDown('slow');
                    }
                    else {
                        $( ".peekaboo" ).slideUp('slow');   
                    }
                }
            });
        },

        promoItemsEffects: function() {
            $(".promo-item").hover(
                function(){ $(this).find('.wrap button').addClass('animated pulse') }, 
                function(){ $(this).find('.wrap button').removeClass('animated pulse') }
                )
            } 
        };

}(jQuery.noConflict());
	
jQuery(document).ready(function() {
	Fool.Base.initialize();
});