"use strict";

// Make <table>s responsive.
var FoolResponsiveTables = (function ($) {
    var my = {};

    function enableResponsiveTable(table) {
        var element = $(table);

        // Create the wrapper element with inner <div> to style.
        var scrollWrapper = $('<div />', {
            'class': 'responsive-table-scrollable',
            'html': '<div />'
        }).insertBefore(element);

        // Move the scrollable element inside the wrapper element
        element.appendTo(scrollWrapper.find('div'));

        // Check if the element is wider than its parent and thus needs to be scrollable.
        adjustClasses(element)

        // When the viewport size is changed, check again if the element needs to be scrollable
        $(window).bind('resize orientationchange', function() { 
            adjustClasses(element);
        });
    }

    function adjustClasses(table) {
        var table = $(table);
        var scrollWrapper = table.closest('div.responsive-table-scrollable');

        if (table.outerWidth() > scrollWrapper.outerWidth()) {
            scrollWrapper.addClass('responsive-table-has-scroll');
        } else {
            scrollWrapper.removeClass('responsive-table-has-scroll');
        }
    }

    $(document).ready(function(){
        // Add .responsive-table class to any table within an article, but not in sidebars or in forums.
        if (!$('body').hasClass('bbpress')) {
            $('article table:not(.responsive-table-no)').addClass('responsive-table');
        }

        // Remove .responsive-table class from .sortable tables, since the two don't play nicely together. 
        /*if ($('table').hasClass('sortable')) {
            $('table').removeClass('responsive-table');
        }*/

        $('table.responsive-table').each(function() {
            enableResponsiveTable(this);
        });
    });

    my.update = function() {
        $('table.responsive-table').each(function() {
            adjustClasses(this);
        });
    }

    return my;
}(jQuery));
