
Fool.Theme = function ($) {
    
    return {

        initialize: function () {
            this.navigationDisplay();
            this.showNavigationOnHomepage();
            this.mainPageModuleNavToggle();
            this.limitIssueCount();
            this.toggleFaq();
        },

        navigationDisplay: function () {
            /* show/hide site navigation */
            $("#site-nav").mouseover(function () {
                $(this).removeClass().addClass("site-nav-show");
            }).mouseout(function () {
                $(this).removeClass().addClass("site-nav-hide");
            });
            
            var saTab = $("#main-menu li a[title^='Motley Fool Share Advisor']");
            saTab.parent().addClass('share-advisor-tab');
            var saTabLink = saTab.attr('href');
            saTab.attr('href', saTabLink + "?source=a7474tn0070001");

            var saTab = $("#main-menu li a[title^='Motley Fool Hidden Gems']");
            saTab.parent().addClass('hidden-gems-tab');
            var saTabLink = saTab.attr('href');
            saTab.attr('href', saTabLink + "?source=a7474tn0070001");

            var saTab = $("#main-menu li a[title^='Motley Fool Pro']");
            saTab.parent().addClass('pro-tab');
            var saTabLink = saTab.attr('href');
            saTab.attr('href', saTabLink + "?source=a7474tn0070001");

            var saTab = $("#main-menu li a[title^='Motley Fool Dividend Investor']");
            saTab.parent().addClass('dividend-investor-tab');
            var saTabLink = saTab.attr('href');
            saTab.attr('href', saTabLink + "?source=a7474tn0070001");

            var saTab = $("#main-menu li a[title^='Motley Fool MDP']");
            saTab.parent().addClass('mdp-tab');
            var saTabLink = saTab.attr('href');
            saTab.attr('href', saTabLink + "?source=a7474tn0070001");
            
        },

        showNavigationOnHomepage: function () {
            /* add clasenames to show sub-navigation when on home page (wp menu won't make home current by default - ugh!) */
            $("body.home #main-menu li, body.single #main-menu li").first().addClass("current-menu-item menu-item-home current_page_item");
        },

        limitIssueCount: function () {

            // Limits the number of issues diplayed on the main page of newsletter sites.
            $(".home .issue-item").hide();
            $(".home .issue-item:lt(5)").show();
        },

        toggleFaq: function () {
            $('.faqs dd').hide();
            $('.faqs dt a').click(function () {
          
                if ($(this).hasClass('selected')) {
                    $(this).removeClass('selected');
                    $(this).parent().next().slideUp();
                } else {
                    $('.faqs dt a').removeClass('selected');
                    $(this).addClass('selected');
                    $('.faqs dd').slideUp();
                    $(this).parent().next().slideDown();
                }
                return false;
            });
        },

        mainPageModuleNavToggle: function () {
            //show/hide main page module content divs.
               
            $(".nav-toggle").click(function () {
              //get collapse content selector
                var content_selector = $(this).attr("href");
                var nav_link = $(this).innerHtml;
                var active_tab = $(this).parent();
                var inactive_tab = $(this).parent().siblings();
 
              //make the collapse content to be shown or hide
                var toggle_switch = $(this);
                $(content_selector).toggle(function () {
                    if ($(this).css("display") == "none") {
                        toggle_switch.html(nav_link);
                        active_tab.removeClass("tab-hilite");
                    } else {
                        toggle_switch.html(nav_link);
                        $('.info-module').not(this).hide(0);
                        active_tab.addClass("tab-hilite");
                        inactive_tab.removeClass("tab-hilite");
                    }

                    $(".module-close").click(function () {
                        $('.info-module').hide(0);
                        active_tab.removeClass("tab-hilite");
                    });


                });
            });
        }}

}(jQuery.noConflict());
    
jQuery(document).ready(function () {
    Fool.Theme.initialize();
});
    
